summaryrefslogtreecommitdiff
path: root/sys-kernel/installkernel
diff options
context:
space:
mode:
Diffstat (limited to 'sys-kernel/installkernel')
-rw-r--r--sys-kernel/installkernel/Manifest1
-rw-r--r--sys-kernel/installkernel/installkernel-68.ebuild245
2 files changed, 246 insertions, 0 deletions
diff --git a/sys-kernel/installkernel/Manifest b/sys-kernel/installkernel/Manifest
index a50073ee205b..4692a61f9a7a 100644
--- a/sys-kernel/installkernel/Manifest
+++ b/sys-kernel/installkernel/Manifest
@@ -2,3 +2,4 @@ DIST installkernel-63.tar.gz 30695 BLAKE2B c96f4b7b4384291b202be2e971255be5793f7
DIST installkernel-65.tar.gz 32895 BLAKE2B eff2be3ef8889359b5bde765131b3aab432fffd08a5e35ede597a5650c1bd209a71dae6ac40b34191a853b5ab6ef3aca7dfda00a29d3dcf723f81537e2924d69 SHA512 3d1f50782dba7a308ed16c144af75dcff217a956af80f697903a0a12e8bda6a78fd63e8c9c6fa4f6ee2bb306f78a90b93eb3b3062377096f43dc014fc6185aa0
DIST installkernel-66.tar.gz 32894 BLAKE2B 21659aca2f6847cab24ac96b952fa286be964ce478b21d499f2eadf624c83ab528c094d760429739236269fb2c671b03a9ef92b40ebfa99bc643f664e61aed2d SHA512 43c3b8949d3faa5ffe63ec6c7fe3cf44927de1f8728b98fb833ab2a4ff5be3636859e1aa4be977ac1d90c3215bd9ab1ad11eaa990beedeeace8abf40964d83d0
DIST installkernel-67.tar.gz 32930 BLAKE2B cb9776f3c6cc8df3abe0defbde81986ebffb4ee96b8d1c507dcf71342dbfe9a974c432c18a4b4285ba1a99074b87cc1d0154c3e15df9e1edf26f0cbc006d60e9 SHA512 7b3d777f3338b1e45cb4ee6cbcb23397eabd9df533fc1780b41181e2818a8496e7c4237a2baa7e4fdcc0b82c255fad7646e501b5cdd8c12ce39ce7e40b8498b4
+DIST installkernel-68.tar.gz 32995 BLAKE2B 807a06d9b35cf883939aa02e0e8622c42255279909637ab9d6e665c7a80045c87c5a28569475cf76b015be7c11d176d59c27de9f0195a88b928ece22051908a9 SHA512 ad9cd8ee2ee6261305b4c65e736aa0b963b310f724e5a044da258b75e3346ed5f830d0c93755f827641b5df7e887c5a91db0072a847c60831e33780aa751473c
diff --git a/sys-kernel/installkernel/installkernel-68.ebuild b/sys-kernel/installkernel/installkernel-68.ebuild
new file mode 100644
index 000000000000..276bb3137d23
--- /dev/null
+++ b/sys-kernel/installkernel/installkernel-68.ebuild
@@ -0,0 +1,245 @@
+# Copyright 2019-2026 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit eapi9-ver linux-info
+
+DESCRIPTION="Gentoo fork of installkernel script from debianutils"
+HOMEPAGE="
+ https://github.com/projg2/installkernel-gentoo
+ https://wiki.gentoo.org/wiki/Installkernel
+"
+
+if [[ ${PV} == 9999 ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://github.com/projg2/installkernel-gentoo.git"
+else
+ SRC_URI="https://github.com/projg2/installkernel-gentoo/archive/v${PV}.tar.gz -> ${P}.tar.gz"
+ S="${WORKDIR}/${PN}-gentoo-${PV}"
+ KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~m68k ~mips ~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86"
+fi
+
+LICENSE="GPL-2+"
+SLOT="0"
+IUSE="dracut efistub grub refind systemd systemd-boot ugrd uki ukify"
+REQUIRED_USE="
+ systemd-boot? ( systemd )
+ ukify? ( uki )
+ ?? ( dracut ugrd )
+"
+# systemd-boot could be made to work without the systemd flag, but this
+# makes no sense since in systemd(-utils) the boot flag already
+# requires the kernel-install flag.
+#
+# Ukify hooks do nothing if the layout is not uki, so force this here.
+#
+# Only one initramfs generator flag can be selected. Note that while
+# both dracut and ukify are UKI generators we don't block those because
+# enabling both results in building an initramfs only with dracut and
+# building an UKI with ukify, which is a valid configuration.
+
+RDEPEND="
+ !<=sys-kernel/installkernel-systemd-3
+ dracut? (
+ >=sys-kernel/dracut-110
+ uki? (
+ || (
+ sys-apps/systemd[boot(-)]
+ sys-apps/systemd-utils[boot(-)]
+ )
+ )
+ )
+ efistub? (
+ systemd? ( >=app-emulation/virt-firmware-24.7 )
+ !systemd? ( sys-boot/uefi-mkconfig )
+ )
+ grub? ( sys-boot/grub )
+ refind? ( sys-boot/refind )
+ systemd? (
+ || (
+ >=sys-apps/systemd-255[kernel-install(-)]
+ >=sys-apps/systemd-utils-255[kernel-install(-)]
+ )
+ )
+ systemd-boot? (
+ || (
+ sys-apps/systemd[boot(-)]
+ sys-apps/systemd-utils[boot(-)]
+ )
+ )
+ ukify? (
+ || (
+ >=sys-apps/systemd-256[boot(-),ukify(-)]
+ >=sys-apps/systemd-utils-256[boot(-),ukify(-)]
+ )
+ )
+ ugrd? ( >=sys-kernel/ugrd-1.31.2 )
+ !=sys-apps/systemd-255.2-r1
+ !=sys-apps/systemd-255.2-r0
+ !~sys-apps/systemd-255.1
+ !~sys-apps/systemd-255.0
+ !=sys-apps/systemd-254.8-r0
+ !=sys-apps/systemd-254.7-r0
+ !~sys-apps/systemd-254.6
+ !<=sys-apps/systemd-254.5-r1
+" # Block against systemd that still installs dummy install.conf
+
+pkg_setup() {
+ use efistub && CONFIG_CHECK="~EFI_STUB" linux-info_pkg_setup
+}
+
+src_install() {
+ keepdir /etc/kernel/install.d
+ keepdir /etc/kernel/preinst.d
+ keepdir /etc/kernel/postinst.d
+ keepdir /usr/lib/kernel/install.d
+ keepdir /usr/lib/kernel/preinst.d
+ keepdir /usr/lib/kernel/postinst.d
+
+ exeinto /usr/lib/kernel/preinst.d
+ doexe hooks/05-check-chroot.install
+ doexe hooks/99-check-diskspace.install
+ use dracut && doexe hooks/52-dracut.install
+ use ukify && doexe hooks/60-ukify.install
+
+ exeinto /usr/lib/kernel/postinst.d
+ doexe hooks/99-write-log.install
+ use grub && doexe hooks/91-grub-mkconfig.install
+ use efistub && doexe hooks/95-efistub-uefi-mkconfig.install
+ use refind && doexe hooks/95-refind-copy-icon.install
+
+ exeinto /usr/lib/kernel/install.d
+ doexe hooks/systemd/00-00machineid-directory.install
+ doexe hooks/systemd/05-check-chroot.install
+ doexe hooks/systemd/05-check-config.install
+ doexe hooks/systemd/10-copy-prebuilt.install
+ doexe hooks/systemd/85-check-diskspace.install
+ doexe hooks/systemd/90-compat.install
+ doexe hooks/systemd/90-zz-update-static.install
+ doexe hooks/systemd/99-write-log.install
+ use dracut && doexe hooks/systemd/52-dracut.install
+ use grub && doexe hooks/systemd/91-grub-mkconfig.install
+ use efistub && doexe hooks/systemd/95-efistub-kernel-bootcfg.install
+ use refind && doexe hooks/systemd/95-refind-copy-icon.install
+
+ if use grub && use uki; then
+ exeinto /etc/grub.d
+ doexe grub/05_uki
+ fi
+
+ if use systemd; then
+ sed -e 's/${SYSTEMD_KERNEL_INSTALL:=0}/${SYSTEMD_KERNEL_INSTALL:=1}/g' -i installkernel ||
+ die "enabling systemd's kernel-install failed"
+ fi
+
+ # set some default config using the flags we have anyway
+ touch "${T}/install.conf" || die
+ echo "# This file is managed by ${CATEGORY}/${PN}" >> "${T}/install.conf" || die
+ if use uki; then
+ echo "layout=uki" >> "${T}/install.conf" || die
+ elif use efistub; then
+ echo "layout=efistub" >> "${T}/install.conf" || die
+ elif use grub; then
+ echo "layout=grub" >> "${T}/install.conf" || die
+ elif use systemd-boot; then
+ echo "layout=bls" >> "${T}/install.conf" || die
+ else
+ echo "layout=compat" >> "${T}/install.conf" || die
+ fi
+
+ if use dracut; then
+ echo "initrd_generator=dracut" >> "${T}/install.conf" || die
+ if ! use ukify; then
+ if use uki; then
+ echo "uki_generator=dracut" >> "${T}/install.conf" || die
+ else
+ echo "uki_generator=none" >> "${T}/install.conf" || die
+ fi
+ fi
+ elif use ugrd; then
+ echo "initrd_generator=ugrd" >> "${T}/install.conf" || die
+ else
+ echo "initrd_generator=none" >> "${T}/install.conf" || die
+ fi
+
+ if use ukify; then
+ echo "uki_generator=ukify" >> "${T}/install.conf" || die
+ else
+ if ! use dracut; then
+ echo "uki_generator=none" >> "${T}/install.conf" || die
+ fi
+ fi
+
+ insinto /usr/lib/kernel
+ doins "${T}/install.conf"
+
+ insinto /etc/logrotate.d
+ newins installkernel.logrotate installkernel
+ keepdir /var/lib/misc
+
+ into /
+ dosbin installkernel
+ doman installkernel.8
+
+ einstalldocs
+}
+
+pkg_postinst() {
+ # show only when upgrading to 14+
+ if ver_replacing -lt 14; then
+ elog "Version 14 and up of ${PN} effectively merges"
+ elog "${PN}-gentoo and ${PN}-systemd."
+ elog "Switching between the traditional installkernel and systemd's"
+ elog "kernel-install is controlled with the systemd USE flag or the"
+ elog "SYSTEMD_KERNEL_INSTALL environment variable."
+ elog
+ elog "See the installkernel wiki page[1] for more details."
+ elog
+ elog "[1]: https://wiki.gentoo.org/wiki/Installkernel"
+ elog
+ fi
+
+ # show only on first install of version 20+
+ if [[ -z "${REPLACING_VERSIONS}" ]] || ver_replacing -lt 20; then
+ if has_version "sys-boot/grub" && ! use grub; then
+ elog "sys-boot/grub is installed but the grub USE flag is not enabled."
+ elog "Users may want to enable this flag to automatically update the"
+ elog "bootloader configuration on each kernel install."
+ fi
+ if ( has_version "sys-apps/systemd[boot]" ||
+ has_version "sys-apps/systemd-utils[boot]" ) &&
+ ! use systemd-boot; then
+ elog "systemd-boot is installed but the systemd-boot USE flag"
+ elog "is not enabled. Users should enable this flag to install kernels"
+ elog "in a layout that systemd-boot understands and to automatically"
+ elog "update systemd-boot's configuration on each kernel install."
+ fi
+ fi
+
+ if use efistub; then
+ ewarn "Automated EFI Stub booting is highly experimental. UEFI implementations"
+ ewarn "often differ between vendors and as a result EFI stub booting is not"
+ ewarn "guaranteed to work for all UEFI systems. Ensure an alternative method"
+ ewarn "of booting the system is available before rebooting."
+ fi
+
+ # Initialize log file if there is none
+ dodir /var/log
+ local log=${ROOT}/var/log/installkernel.log
+ if [[ ! -s ${log} ]]; then
+ echo -e \
+"DATE\t"\
+"KI_VENDOR\t"\
+"VERSION\t"\
+"CONF_ROOT\t"\
+"LAYOUT\t"\
+"INITRD_GEN\t"\
+"UKI_GEN\t"\
+"BOOT_ROOT\t"\
+"KERNEL_REL_PATH\t"\
+"INITRD_REL_PATH\t"\
+"PLUGIN_OVERRIDE\t"\
+>> "${log}" || die
+ fi
+}